import math as m
import numpy as np

def f(x):
  return x-m.exp(1-x**2)

def df(x, dx):
  return (f(x)-f(x-dx))/dx

x=1.5
tolerance=1e-6
delta=1.0
dx=0.1

while abs(delta)>tolerance:
  delta=-f(x)/df(x, dx)
  x+=delta
  dx=delta
